`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/04/15 19:35:26
// Design Name: 
// Module Name: BCD_down_4d
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module BCD_down_4d(
    digit_3,
    digit_2,
    digit_1,
    digit_0,
    init_value_3,
    init_value_2,
    init_value_1,
    init_value_0,
    clk,
    rst,
    en,
    LED_out_to_ctl
    );
    output [3:0] digit_3;
    output [3:0] digit_2;
    output [3:0] digit_1;
    output [3:0] digit_0;
    output reg LED_out_to_ctl;

    input [3:0] init_value_3;
    input [3:0] init_value_2;
    input [3:0] init_value_1;
    input [3:0] init_value_0;
    input clk, rst, en;

    wire br0, br1, br2, br3;
    wire decrease_enable;

    always @*
        if (digit_0 == 4'd0 && digit_1 == 4'd0 && digit_2 == 4'd0 && digit_3 == 4'd0)
            LED_out_to_ctl = 1'b1;
        else
            LED_out_to_ctl = 1'b0;
            
    assign decrease_enable = en && (~((digit_0 == 4'd0) && (digit_1 == 4'd0) && (digit_2 == 4'd0) && (digit_3 == 4'd0)));
    
    BCD_down U0(
    .value(digit_0), 
    .borrow(br0), 
    .clk(clk), 
    .rst(rst), 
    .decrease(decrease_enable),
    .init_value(init_value_0), 
    .limit(4'd9)
    );

    BCD_down U1(
    .value(digit_1), 
    .borrow(br1), 
    .clk(clk), 
    .rst(rst), 
    .decrease(br0),
    .init_value(init_value_1), 
    .limit(4'd5)
    );

    BCD_down U2(
    .value(digit_2), 
    .borrow(br2), 
    .clk(clk), 
    .rst(rst), 
    .decrease(br1),
    .init_value(init_value_2), 
    .limit(4'd9)
    );

    BCD_down U3(
    .value(digit_3), 
    .borrow(br3), 
    .clk(clk), 
    .rst(rst), 
    .decrease(br2),
    .init_value(init_value_3), 
    .limit(4'd9)
    );


endmodule




