`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/04/01 19:35:26
// Design Name: 
// Module Name: BCD_up_2d_minute
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module BCD_up_2d_minute(
    digit_1,
    digit_0,
    rst,
    clk,
    en,
    stop_to_zero
    );
    output [3:0] digit_0, digit_1;
    input clk, rst, en, stop_to_zero;

    wire c0, c1;

    wire [3:0] init_value_tmp_1, init_value_tmp_0;
    reg [3:0] init_final_value_1, init_final_value_0;

    assign init_value_tmp_0 = digit_0;
    assign init_value_tmp_1 = digit_1;

    always @*
        if (stop_to_zero == 1'b0)
            begin
            init_final_value_1 = init_value_tmp_1;
            init_final_value_0 = init_value_tmp_0; 
            end
        else
            begin
            init_final_value_1 = 4'd0;
            init_final_value_0 = 4'd0;
            end

    BCD_up U0(
    .value(digit_0), 
    .carry_out(c0), 
    .clk(clk), 
    .rst(rst), 
    .increase(en),
    .init_value(init_final_value_0), 
    .limit(4'd9)
    );
    
    BCD_up U1(
    .value(digit_1), 
    .carry_out(c1), 
    .clk(clk), 
    .rst(rst), 
    .increase(c0),
    .init_value(init_final_value_1), 
    .limit(4'd5)
    );


endmodule




