`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/04/16 23:58:15
// Design Name: 
// Module Name: fsm_7_2
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

`define SET_TIME 2'b00
`define PAUSE 2'b01
`define COUNT 2'b10
`define ENABLE 1'b1
`define DISABLE 1'b0

module fsm_7_2(
    count_enable,
    clk,
    rst,
    time_set,
    set,
    stop,
    pb_count,
    pb_stop,
    setting_on
);
    output reg count_enable;
    output reg set;
    output reg stop;
    output setting_on;
    input time_set;
    input pb_stop, pb_count;
    input clk, rst;
    
    reg [1:0] state;
    reg [1:0] next_state;


    always @*
        case (state)
          `SET_TIME: 
           if (time_set == 1'b1)
                begin
                  next_state = `SET_TIME;
                  count_enable = `DISABLE;
                  set = `ENABLE;
                  stop = `DISABLE;
                end
           else
                begin
                next_state = `PAUSE;
                count_enable = `DISABLE;
                set = `DISABLE;
                stop = `DISABLE;
                end
          `PAUSE:
            if (time_set == 1'b1)
                begin
                  next_state = `SET_TIME;
                  count_enable = `DISABLE;
                  set = `ENABLE;
                  stop = `DISABLE;
                end
            else if (pb_stop == 1'b1 && time_set != 1'b1)
                begin
                next_state = `PAUSE;
                count_enable = `DISABLE;
                set = `DISABLE;
                stop = `ENABLE;
                end
            else if (pb_count == 1'b1 && pb_stop != 1'b1)
                begin
                next_state = `COUNT;
                count_enable = `ENABLE;
                set = `DISABLE;
                stop = `DISABLE;
                end
            else
                begin
                next_state = `PAUSE;
                count_enable = `DISABLE;
                set = `DISABLE;
                stop = `DISABLE;
                end 
          
          `COUNT:
            if (time_set == 1'b1)
                begin
                  next_state = `SET_TIME;
                  count_enable = `DISABLE;
                  set = `ENABLE;
                  stop = `DISABLE;
                end
            else if (pb_stop == 1'b1 && time_set != 1'b1)
                begin
                next_state = `PAUSE;
                count_enable = `DISABLE;
                set = `DISABLE;
                stop = `ENABLE;
                end
            else if (pb_count == 1'b1 && pb_stop != 1'b1)
                begin
                next_state = `PAUSE;
                count_enable = `ENABLE;
                set = `DISABLE;
                stop = `DISABLE;
                end
            else
                begin
                next_state = `COUNT;
                count_enable = `ENABLE;
                set = `DISABLE;
                stop = `DISABLE;
                end
          default:
              begin
              next_state = `SET_TIME;
              count_enable = `DISABLE;
              set = `DISABLE;
              stop = `DISABLE;
              end
          endcase
          


    always @(posedge clk or posedge rst)
        if (rst)
            state <= `SET_TIME;
        else
            state <= next_state;

    assign setting_on = set || stop;
endmodule
