`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/04/20 16:30:11
// Design Name: 
// Module Name: lab_7_1_top
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module lab_7_1_top(
    D_ssd,
    ssd_ctl,
    clk,
    clk_1Hz,
    clk_100Hz,
    clk_ssd_ctl,
    rst,
    pb_count_pause,
    pb_lap
    );

    output [7:0] D_ssd;
    output [3:0] ssd_ctl;
    input clk, clk_100Hz, clk_1Hz;
    input rst;
    input [1:0] clk_ssd_ctl;
    input pb_count_pause, pb_lap;

    wire lap_enable;
    wire count_enable;

    wire [3:0] digit_3, digit_2, digit_1, digit_0;
    wire [3:0] digit_3_out, digit_2_out, digit_1_out, digit_0_out;

    wire [3:0] ssd_in;
   

    fsm U03(
    .select_mode_change(pb_count_pause),
    .clk(clk),
    .rst(rst),
    .count_enable(count_enable)
    );

    fsm_for_lap U033(
    .select_mode_change(pb_lap),
    .clk(clk),
    .rst(rst),
    .lap_enable(lap_enable)
    );

    /*fsm_for_rst U0333(
    .select_mode_change(out_pulse_sec_min),
    .clk(clk_100Hz),
    .rst_n(rst_n),
    .current_state(curr_state_sec_min)
    );*/


    BCD_up_4d U1(
    .digit_3(digit_3),
    .digit_2(digit_2),
    .digit_1(digit_1),
    .digit_0(digit_0),
    .rst(rst),
    .clk(clk_1Hz),
    .count_enable(count_enable)
    );

    lap U2(
    .digit_3_in(digit_3),
    .digit_2_in(digit_2),
    .digit_1_in(digit_1),
    .digit_0_in(digit_0),
    .digit_3_out(digit_3_out),
    .digit_2_out(digit_2_out),
    .digit_1_out(digit_1_out),
    .digit_0_out(digit_0_out),
    .clk(clk),
    .enable(lap_enable), 
    .rst(rst)
    );

    scan_freq_ctl U3(
    .ssd_in(ssd_in),
    .ssd_ctl(ssd_ctl),
    .in_0(digit_0_out),
    .in_1(digit_1_out),
    .in_2(digit_2_out),
    .in_3(digit_3_out),
    .clk_ctl_en(clk_ssd_ctl),
    .rst(rst)
    );
    
    display U4(.D_ssd(D_ssd), .i(ssd_in));

endmodule
