`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/04/20 16:30:11
// Design Name: 
// Module Name: lab_7_2_top
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
`define ENABLE 1'b1
module lab_7_2_top(
    D_ssd,
    ssd_ctl,
    LED_out,
    clk,
    clk_1Hz,
    clk_100Hz,
    clk_ssd_ctl,
    pb_pause,
    pb_stop,
    pb_hour,
    pb_min,
    time_set,
    rst,
    stop_to_zero
    );

    output [7:0] D_ssd;
    output [3:0] ssd_ctl;
    output [15:0] LED_out;

    input clk, clk_100Hz, clk_1Hz;
    input [1:0] clk_ssd_ctl;
    input rst;
    input pb_pause, pb_stop, pb_hour, pb_min;
    input time_set;

    input stop_to_zero;

    wire setting_on;

    wire set, stop;

    wire LED_out_to_ctl;
  
    wire [3:0] digit_3, digit_2, digit_1, digit_0;
    wire [3:0] init_value_3, init_value_2, init_value_1, init_value_0;
    wire [3:0] final_value_3, final_value_2, final_value_1, final_value_0;
    
    reg [3:0] init_final_value_3, init_final_value_2, init_final_value_1, init_final_value_0;
    
    wire [3:0] ssd_in;


    fsm_7_2 U03(
    .count_enable(count_enable),
    .clk(clk),
    .rst(rst),
    .time_set(time_set),
    .set(set),
    .stop(stop),
    .pb_count(pb_pause),
    .pb_stop(pb_stop),
    .setting_on(setting_on)
);


    BCD_up_2d_hour U05(
    .digit_1(init_value_3),
    .digit_0(init_value_2),
    .rst(~setting_on),
    .clk(pb_hour),
    .en(`ENABLE),
    .stop_to_zero(stop_to_zero)
    );

    BCD_up_2d_minute U06(
    .digit_1(init_value_1),
    .digit_0(init_value_0),
    .rst(~setting_on),
    .clk(pb_min),
    .en(`ENABLE),
    .stop_to_zero(stop_to_zero)
    );
    

    BCD_down_4d U07(
    .digit_3(digit_3),
    .digit_2(digit_2),
    .digit_1(digit_1),
    .digit_0(digit_0),
    .init_value_3(init_value_3),
    .init_value_2(init_value_2),
    .init_value_1(init_value_1),
    .init_value_0(init_value_0),
    .clk(clk_1Hz),
    .rst(setting_on),
    .en(count_enable),
    .LED_out_to_ctl(LED_out_to_ctl)
    );

    digit_selector U08(
    .final_value_3(final_value_3),
    .final_value_2(final_value_2),
    .final_value_1(final_value_1),
    .final_value_0(final_value_0),
    .init_value_3(init_value_3),
    .init_value_2(init_value_2),
    .init_value_1(init_value_1),
    .init_value_0(init_value_0),
    .digit_3(digit_3),
    .digit_2(digit_2),
    .digit_1(digit_1),
    .digit_0(digit_0),
    .set(set)
    );
 
   
    scan_freq_ctl U3(
    .ssd_in(ssd_in),
    .ssd_ctl(ssd_ctl),
    .in_0(final_value_0),
    .in_1(final_value_1),
    .in_2(final_value_2),
    .in_3(final_value_3),
    .clk_ctl_en(clk_ssd_ctl),
    .rst(rst)
    );

    display U4(.D_ssd(D_ssd), .i(ssd_in));

    LED_ctl U5( 
    .LED_in(LED_out_to_ctl),
    .LED_out(LED_out)
);
endmodule
